package com.genericparallel;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import org.apache.xmlbeans.XmlObject;

public class VerifyTransactions {

	private static Map<String,Map<String,Integer>> cache = new HashMap<String,Map<String,Integer>>();

	public static void record(String accountNumber,String stage) throws Exception {
		synchronized(cache) {
			Map<String, Integer> map = getAccountMap(accountNumber);

			Integer count = getAccountStage(map, stage); 
			
			count = new Integer(count.intValue()+1);
			map.put(stage,count);
		}
	}

	public static XmlObject getStats(String accountNumber) throws Exception {
		Map<String, Integer> map = getAccountMap(accountNumber);


		StringBuilder sb = new StringBuilder();
		sb.append("<stats>");
		Set<String> keySet = map.keySet();
		ArrayList<String> sorted = new ArrayList<String>(keySet);
		Collections.sort(sorted);
		for (String stage : sorted) {
			Integer count = map.get(stage);
			sb.append("<"+stage+">").append(count.intValue()).append("</"+stage+">");
		}
		sb.append("</stats>");
			
		return XmlObject.Factory.parse(sb.toString() );
	}

	private static Integer getAccountStage(Map<String, Integer> map, String stage) {
		Integer count = map.get(stage);
		if( count == null ) {
			count = new Integer(0);
			map.put(stage,count);
		}
		return count;
	}

	private static Map<String, Integer> getAccountMap(String accountNumber) {
		Map<String,Integer> map = cache.get(accountNumber);
		if( map == null ) {
			map = new HashMap<String,Integer>();
			cache.put(accountNumber,map);
		}
		return map;
	}
}